> ## Documentation Index
> Fetch the complete documentation index at: https://developer.watson-orchestrate.ibm.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Chat With Orchestrate Assistant As Stream



## OpenAPI

````yaml post /v1/orchestrate/runs/stream
openapi: 3.1.0
info:
  title: WxO Server API
  summary: API for the next gen watsonx Orchestrate stack
  description: >+

    The watsonx Orchestrate Server provides a set of APIs to power the watsonx
    Orchestrate AI assistant. This includes the following core services:


    * Orchestrate Assistant - a built-in AI assistant that powers the
    Orchestrate end-user experience.

    * Custom Assistants - a service layer for interacting with existing AI
    assistatns (such as those in watsonx Assistant).

    * Message Threads - a chat history and async message tracking store.

    * Document Store - manage collections of documents in nearly any format
    including text, pdf, html and many more.

    * Information Extraction - automatically extract clean text and images from
    any document in the Document Store.  Also extract other useful metadata like
    questions answered, keywords, and named entities.

    * Embedding - generate vector embeddings for text and images in the Document
    Store.

    * Vector Index and Retrieval - automatically index documents with rich
    metadata for vector search or hybrid search.

    * Search Engine - create a Gen AI powered search engine that works like Bing
    or Google.

    * Query Engine - configure your own RAG (Retrieval Augmented Generation)
    engine supporting advanced retrieval patterns and automated data management.

    * Model Proxy - create your own LLM model endpoints for chat completions and
    embeddings.  Supports IBM watsonx.ai, IBM BAM, OpenAI, MistralAI, or Ollama
    for local models.


    WxO API Server utilizes the following open source projects:


    * [PostgreSQL](https://www.postgresql.org/)

    * [PGVector](https://github.com/pgvector/pgvector)

    * [LlamaIndex](https://docs.llamaindex.ai/en/stable/)

    * [LangChain](https://python.langchain.com/docs/get_started/introduction)

    * [FastAPI](https://fastapi.tiangolo.com/)

    * [Unstructured](https://unstructured.io/)

    * [Celery](https://docs.celeryproject.org/en/stable/)

  version: 0.1.0
servers:
  - url: https://{api_endpoint}
    description: version
security: []
paths:
  /v1/orchestrate/runs/stream:
    post:
      tags:
        - Orchestrate Agent
      summary: Chat With Orchestrate Assistant As Stream
      operationId: >-
        Chat_with_Orchestrate_Assistant_as_Stream_v1_orchestrate_runs_stream_post
      parameters:
        - name: stream_timeout
          in: query
          required: false
          schema:
            type: integer
            default: 60000
            title: Stream Timeout
        - name: multiple_content
          in: query
          required: false
          schema:
            type: boolean
            default: false
            title: Multiple Content
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RunOrchestrate'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RunEvent'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    RunOrchestrate:
      properties:
        message:
          anyOf:
            - $ref: '#/components/schemas/CreateMessage'
            - type: 'null'
        thread_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Thread Id
        llm_params:
          anyOf:
            - $ref: '#/components/schemas/TextGenerationParameters'
            - type: 'null'
        guardrails:
          anyOf:
            - $ref: '#/components/schemas/Guardrails-Input'
            - type: 'null'
        context:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Context
        agent_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Agent Id
        additional_parameters:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Additional Parameters
        environment_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Environment Id
        version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Version
        context_variables:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Context Variables
          description: >-
            Context variables for the agent execution (e.g., {'wxo_email_id':
            'user@domain.com', 'wxo_user_name': 'John Doe'})
      type: object
      title: RunOrchestrate
    RunEvent:
      properties:
        id:
          type: string
          title: Id
        event:
          $ref: '#/components/schemas/EventType'
        data:
          additionalProperties: true
          type: object
          title: Data
      type: object
      required:
        - id
        - event
        - data
      title: RunEvent
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    CreateMessage:
      properties:
        role:
          type: string
          title: Role
        content:
          anyOf:
            - items:
                $ref: '#/components/schemas/AssistantContent'
              type: array
            - type: string
          title: Content
        mentions:
          anyOf:
            - items:
                anyOf:
                  - $ref: '#/components/schemas/Mention'
                  - $ref: '#/components/schemas/AssistantMention'
              type: array
            - type: 'null'
          title: Mentions
        document_ids:
          anyOf:
            - items:
                type: string
                format: uuid
              type: array
            - type: 'null'
          title: Document Ids
        parent_message_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Parent Message Id
        additional_properties:
          anyOf:
            - $ref: '#/components/schemas/AdditionalProperties'
            - type: 'null'
        assistant_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Assistant Id
        context:
          anyOf:
            - $ref: '#/components/schemas/Context'
            - type: 'null'
        step_history:
          anyOf:
            - items:
                additionalProperties: true
                type: object
              type: array
            - type: 'null'
          title: Step History
        message_state:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Message State
      type: object
      required:
        - role
        - content
      title: CreateMessage
    TextGenerationParameters:
      properties:
        beam_width:
          anyOf:
            - type: integer
              maximum: 3
              minimum: 0
            - type: 'null'
          title: Beam width
        decoding_method:
          anyOf:
            - $ref: '#/components/schemas/DecodingMethod'
            - type: 'null'
        include_stop_sequence:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Include Stop Sequence
        length_penalty:
          anyOf:
            - $ref: '#/components/schemas/LengthPenalty'
            - type: 'null'
        max_new_tokens:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Max new tokens
        min_new_tokens:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Min new tokens
        random_seed:
          anyOf:
            - type: integer
              maximum: 4294967295
              minimum: 1
            - type: 'null'
          title: Random seed
        repetition_penalty:
          anyOf:
            - type: number
              multipleOf: 0.01
              maximum: 2
              minimum: 1
            - type: 'null'
          title: Repetition penalty
        return_options:
          anyOf:
            - $ref: '#/components/schemas/TextGenerationReturnOptions'
            - type: 'null'
        stop_sequences:
          anyOf:
            - items:
                type: string
              type: array
              maxItems: 6
              minItems: 1
            - type: 'null'
          title: Stop sequences
          examples:
            - '[" and "]'
        temperature:
          anyOf:
            - type: number
              multipleOf: 0.01
              maximum: 2
              minimum: 0
            - type: 'null'
          title: Temperature
        time_limit:
          anyOf:
            - type: integer
            - type: 'null'
          title: Time limit
        top_k:
          anyOf:
            - type: integer
              maximum: 100
              minimum: 1
            - type: 'null'
          title: Top K
        top_p:
          anyOf:
            - type: number
              multipleOf: 0.01
              maximum: 1
              minimum: 0
            - type: 'null'
          title: Top P (nucleus sampling)
        truncate_input_tokens:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Truncate input tokens
        typical_p:
          anyOf:
            - type: number
              multipleOf: 0.01
              maximum: 1
              minimum: 0.01
            - type: 'null'
          title: Typical P
      additionalProperties: true
      type: object
      title: TextGenerationParameters
    Guardrails-Input:
      properties:
        hap:
          anyOf:
            - $ref: '#/components/schemas/Guardrail'
            - type: 'null'
        social_bias:
          anyOf:
            - $ref: '#/components/schemas/Guardrail'
            - type: 'null'
        pii:
          anyOf:
            - $ref: '#/components/schemas/Guardrail'
            - type: 'null'
      additionalProperties: false
      type: object
      title: Guardrails
    EventType:
      type: string
      enum:
        - run.started
        - run.completed
        - run.failed
        - run.expired
        - run.cancelled
        - run.step.started
        - run.step.completed
        - run.step.failed
        - run.step.delta
        - message.created
        - message.started
        - message.delta
        - message.completed
        - run.step.thinking
        - message.interrupt
        - transcription
        - summary
        - error
        - done
        - planning
        - flow.slot.listen
      title: EventType
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    AssistantContent:
      properties:
        response_type:
          $ref: '#/components/schemas/AssistantContentType'
        json_schema:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Json Schema
        ui_schema:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Ui Schema
        form_data:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Form Data
          default: {}
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        form_operation:
          anyOf:
            - type: string
            - type: 'null'
          title: Form Operation
        sub_type:
          anyOf:
            - type: string
            - type: 'null'
          title: Sub Type
        event_type:
          anyOf:
            - type: string
            - type: 'null'
          title: Event Type
        dps_payload_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Dps Payload Id
      additionalProperties: true
      type: object
      required:
        - response_type
      title: AssistantContent
    Mention:
      properties:
        type:
          type: string
          title: Type
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
      type: object
      required:
        - type
        - id
        - name
      title: Mention
    AssistantMention:
      properties:
        assistant_id:
          type: string
          format: uuid
          title: Assistant Id
        assistant_name:
          type: string
          title: Assistant Name
      type: object
      required:
        - assistant_id
        - assistant_name
      title: AssistantMention
    AdditionalProperties:
      properties:
        wxa_message:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Wxa Message
        display_properties:
          anyOf:
            - $ref: '#/components/schemas/DisplayProperties'
            - type: 'null'
        tool_calls:
          anyOf:
            - items:
                additionalProperties: true
                type: object
              type: array
            - type: 'null'
          title: Tool Calls
        tool_call_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Tool Call Id
        tool_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Tool Name
        wxo_connection_status:
          anyOf:
            - $ref: '#/components/schemas/WxoConnectionStatus'
            - type: 'null'
      type: object
      title: AdditionalProperties
    Context:
      properties:
        values:
          items:
            $ref: '#/components/schemas/ContextKV'
          type: array
          title: Values
          default: []
      type: object
      title: Context
    DecodingMethod:
      type: string
      enum:
        - greedy
        - sample
      title: DecodingMethod
    LengthPenalty:
      properties:
        decay_factor:
          anyOf:
            - type: number
              exclusiveMinimum: 1
            - type: 'null'
          title: Decay factor
        start_index:
          anyOf:
            - type: integer
              minimum: 1
            - type: 'null'
          title: Start index
      additionalProperties: true
      type: object
      title: LengthPenalty
    TextGenerationReturnOptions:
      properties:
        generated_tokens:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Generated Tokens
          default: false
        input_parameters:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Input Parameters
        input_text:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Input text
          default: false
        input_tokens:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Input Tokens
          default: false
        token_logprobs:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Token logprobs
          default: false
        token_ranks:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Token ranks
          default: false
        top_n_tokens:
          anyOf:
            - type: integer
              maximum: 5
              minimum: 0
            - type: 'null'
          title: Top N tokens
      additionalProperties: true
      type: object
      title: TextGenerationReturnOptions
    Guardrail:
      properties:
        input:
          anyOf:
            - $ref: '#/components/schemas/GuardrailConfig'
            - type: 'null'
        output:
          anyOf:
            - $ref: '#/components/schemas/GuardrailConfig'
            - type: 'null'
        mask:
          anyOf:
            - $ref: '#/components/schemas/MaskProperties'
            - type: 'null'
      additionalProperties: false
      type: object
      title: Guardrail
    AssistantContentType:
      type: string
      enum:
        - conversational_search
        - text
        - image
        - option
        - pause
        - iframe
        - connect_to_agent
        - suggestion
        - channel_transfer
        - search
        - user_defined
        - video
        - audio
        - date
        - inline_error
        - chat_with_docs_upload
        - disconnected_apps
        - forms
        - form_operation
        - document_processing_response
      title: AssistantContentType
    DisplayProperties:
      properties:
        skip_render:
          type: boolean
          title: Skip Render
          default: false
        is_async:
          type: boolean
          title: Is Async
          default: false
        form_operation:
          type: string
          title: Form Operation
          default: ''
      type: object
      title: DisplayProperties
    WxoConnectionStatus:
      properties:
        connection_status:
          type: string
          title: Connection Status
        connection_message:
          type: string
          title: Connection Message
      type: object
      title: WxoConnectionStatus
    ContextKV:
      properties:
        key:
          type: string
          title: Key
        value:
          title: Value
      type: object
      required:
        - key
      title: ContextKV
    GuardrailConfig:
      properties:
        enabled:
          type: boolean
          title: Enabled
          default: false
        threshold:
          type: number
          title: Threshold
          default: 0.5
      additionalProperties: false
      type: object
      title: GuardrailConfig
    MaskProperties:
      properties:
        remove_entity_value:
          type: boolean
          title: Remove Entity Value
          default: false
      additionalProperties: false
      type: object
      title: MaskProperties
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````